
;************** ASM file header stuff ***************

	include	"tios.h"
	include	"flib.h"
	include "triglib.h"
	xdef	_main
	xdef	_comment

;******************* Constants ***********************

NO_OF_TABLES	EQU	20

DISTANCE_N1	EQU	6512
DISTANCE_N2	EQU	1209
ARCTAN_X	EQU	100
ARCTAN_Y	EQU	-100
ARCTAN_NEGATIVE	EQU	0	;0 for yes, 1 for no
SIN		EQU	256
COS		EQU	128

SIZE		EQU	256	;Size of 1/4th of table (degrees 0-90)
RADIUS		EQU	100*256	;In pixels

FILLED_RADIUS	EQU	32
FILLED_X	EQU	240-38
FILLED_Y	EQU	128-34

;****************** BSS Section *********************
	BSS

sinetable	ds.w	SIZE*4+1	<= NECESSARY BECAUSE OF OVERFLOW IN generate_sinetable!

	CODE

;************** Start of Fargo program ***************

_main:
	jsr		flib::zap_screen
	move.w		#1,-(sp)
	jsr		tios::FontSetSys
	addq.l		#2,sp

;****************************
;* INITIALIZE SINE TABLE(S) *
;****************************
	move.l		#NO_OF_TABLES,d7

\gloop	pea		s_empty(pc)
	move.w		#NO_OF_TABLES,-(sp)
	move.w		d7,-(sp)
	pea		template_gen(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#4,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY
	lea		10+16(sp),sp

	move.l		#sinetable,a0
	move.l		#SIZE,d1
;	move.l		#RADIUS,d3
	jsr		triglib::init

	dbra		d7,\gloop

	pea		s_done(pc)
	move.w		#NO_OF_TABLES,-(sp)
	move.w		#0,-(sp)
	pea		template_gen(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#4,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY

	lea		triglib::init,a0
	lea		triglib::distance,a1
	sub.l		a0,a1
	move.w		a1,-(sp)
	pea		templateend(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#12,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY
	lea		16+10+10+10(sp),sp

;**********************
;* TEST OF distance() *
;**********************
	move.w		#DISTANCE_N1,d0
	move.w		#DISTANCE_N2,d1
	jsr		triglib::distance
	move.w		d2,-(sp)
	move.w		d1,-(sp)
	move.w		d0,-(sp)
	pea		template_sqrrt(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#24,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY

	lea		triglib::distance,a0
	lea		triglib::arctan,a1
	sub.l		a0,a1
	move.w		a1,-(sp)
	pea		templateend(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#32,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY
	lea		10+10+10+14(sp),sp

;********************
;* TEST OF arctan() *
;********************
	move.w		#ARCTAN_X,d0
	move.w		#ARCTAN_Y,d1
	moveq		#ARCTAN_NEGATIVE,d2
	jsr		triglib::arctan
	move.w		#SIZE,-(sp)
	move.w		d2,-(sp)
	move.w		d1,-(sp)
	move.w		d0,-(sp)
	pea		template_arctan(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#44,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY

	lea		triglib::arctan,a0
	lea		triglib::sin,a1
	sub.l		a0,a1
	move.w		a1,-(sp)
	pea		templateend(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#52,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY
	lea		10+10+10+16(sp),sp

;*****************
;* TEST OF sin() *
;*****************
	move.w		#SIN,d0
	move.w		#RADIUS,d1
	jsr		triglib::sin
	move.w		d2,-(sp)
	move.w		d0,-(sp)
	pea		template_sin(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#64,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY

	lea		triglib::sin,a0
	lea		triglib::cos,a1
	sub.l		a0,a1
	move.w		a1,-(sp)
	pea		templateend(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#72,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY
	lea		10+10+10+12(sp),sp

;*****************
;* TEST OF cos() *
;*****************
	move.w		#COS,d0
	move.w		#RADIUS,d1
	jsr		triglib::cos
	move.w		d2,-(sp)
	move.w		d0,-(sp)
	pea		template_cos(pc)
	pea		buffer(pc)
	jsr		tios::sprintf
	move.w		#4,-(sp)
	pea		buffer(pc)
	move.w		#84,-(sp)
	move.w		#4,-(sp)
	jsr		tios::DrawStrXY
	lea		10+12(sp),sp

;************************
;* Plot a filled circle *
;************************
	move.w		#FILLED_RADIUS,d1

\oloop	move.w		#4*SIZE-1,d0
\ploop	jsr		triglib::sin
	add.w		#FILLED_Y,d2
	move.w		d2,-(sp)
	jsr		triglib::cos
	add.w		#FILLED_X,d2
	move.w		d2,-(sp)
	jsr		flib::pixel_on
	addq.l		#4,sp
	dbra		d0,\ploop

	dbra		d1,\oloop

;************
;* FINISHED *
;************
	jsr		flib::idle_loop
	rts

;****************** Variables ************************


;**************** Byte stuff *************************

template_gen	dc.b	"Generating sine table %d of %d %s",0
s_empty		dc.b	" ",0
s_done		dc.b	"- ok!",0

template_sqrrt	dc.b	"Sqrrt(%d^2+%d^2)=%d",0
template_arctan	dc.b	"Arctan(x:%d, y:%d)=%d (90",176,"=%d)",0
template_sin	dc.b	"Sin(%d)=%d",0
template_cos	dc.b	"Cos(%d)=%d",0

templateend	dc.b	"Routine is %d bytes long",0
buffer		ds.b	50

;*************** End of Fargo program ****************

_comment:	dc.b	"Testing TrigLib",0

	end
