;---------------------------------------------------------------------
;
; init(a0,d1,d3)
;
; Function: Generate a sine table of d1*4 words
;
; Input:    A0.L = Pointer to sine table memory area
;           D1.W = Size of 1/4th of table in #angles. *Must* be a
;                   power of two.
; Output:   Nothing
; Destroys: Nothing
;
;---------------------------------------------------------------------
triglib::init		equ	triglib@0000

;---------------------------------------------------------------------
;
; distance(D0,D1)
;
; Function: Calculate the diagonal of a rectangle with the sides D0
;           and D1.
;
; Input:    D0.W = X side length
;           D1.W = Y side length
; Output:   D2.W = sqrrt(X^2+Y^2)
; Destroys: Nothing
;
;---------------------------------------------------------------------
triglib::distance		equ	triglib@0001

;---------------------------------------------------------------------
;
; arctan(D0,D1,D2)
;
; Function: Calculate arctan(D1/D0)
;
; Input:    D0.W = Delta-X
;           D1.W = Delta-Y
;           D2.W = 0 to return negative angles, otherwise positive
; Output:   D2.W = arctan(D1/D0)
; Destroys: Nothing
;
; Note: The error is 1-2 "degrees".
;
;---------------------------------------------------------------------
triglib::arctan			equ	triglib@0002

;---------------------------------------------------------------------
;
; sin()
;
; Function: Calculate sin(D1)
;
; Input:    D0.W = "angle"
;           D1.W = Radius of circle in pixels
; Output:   D2.W = sin(D1)
; Destroys: Nothing
;
;---------------------------------------------------------------------
triglib::sin			equ	triglib@0003

;---------------------------------------------------------------------
;
; cos()
;
; Function: Calculate cos(D1)
;
; Input:    D0.W = "angle"
;           D1.W = Radius of circle in pixels
; Output:   D2.W = cos(D1)
;
;---------------------------------------------------------------------
triglib::cos			equ	triglib@0004
